#include "StdAfx.h"
#include ".\ndscard.h"





CNdsCard::CNdsCard(void)
{
	m_CardType = "";
	m_SelectMemoryIndex =0;
	m_FilePath = "";

	m_Thread = NULL;
	m_ThreadRun = FALSE;       //ֹ߳
	m_ThreadRunMode = NONEDO;  //߳ģʽ
}

CNdsCard::~CNdsCard(void)
{
}









//======================================================================
//: õַ
//
//======================================================================
CString  CNdsCard::GetErrorString(UINT lParam)
{
	CString error="?????";
	if(lParam == ERROR_DEVICE)
	{
		error=" Device Error";
	}
	if(lParam == ERROR_STOP)
	{
		error=" The compulsion terminates ";
	}
	if(lParam == ERROR_DOING)
	{
		error=" Device Is Running......";
        if(m_ThreadRunMode == CHECKSTRUCTURE)
		{
           error=" Checking......";
		}
		if(m_ThreadRunMode == READALL)
		{
			error=" Reading......";
		}
		if(m_ThreadRunMode == WRITEALL)
		{
			error=" Writing......";
		}
	}
	if(lParam == ERROR_FILE)
	{
		error=" File Error";
	} 
	if(lParam == ERROR_CARD)
	{
		error=" Card Error";
	} 
	if(lParam == ERROR_ICBUSY)
	{
		error=" Memory Busy";
	} 
	if(lParam == ERROR_ICPROTECT)
	{
		error= "Memory Error";//" оƬ";
	} 
	if(lParam == ERROR_ICUNKNOW)
	{
		error=" Unknow Type";
	} 
	return error;
}



                                                           




//==========================================================
//:   
//
//==========================================================
VOID    CNdsCard::StartCheckMemory()
{
	//߳ռ豸,߳
	if(m_ThreadRunMode != NONEDO)
	{
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_ERROR,NULL,ERROR_DOING);		
		return; 
	}

	m_ThreadRun=TRUE;

	m_MemoryTypeList.RemoveAll();

	OutputDebugString("AfxBeginThread(CheckTypeThread, this); \r\n");
	m_ThreadRunMode=CHECKSTRUCTURE;
	m_Thread=AfxBeginThread(CheckStructureThread, this);	
}



//==========================================================
//:   
//
//==========================================================
CString  CNdsCard::GetCardType()
{
	return m_CardType;
}

//==========================================================
//:   
//
//==========================================================
UINT    CNdsCard::GetMemoryTotal()
{
	return (UINT)m_MemoryTypeList.GetCount();
}

//==========================================================
//:   
//
//==========================================================
MEMORY_ENTRY_MODE CNdsCard::GetMemoryMode(UINT index)
{
	if(index >= GetMemoryTotal())
	{
		MEMORY_ENTRY_MODE none=NONE;
		return none;
	}
	MEMORY_TYPE mt=m_MemoryTypeList.GetAt(index);
	return mt.mode;
}

//==========================================================
//:   
//
//==========================================================
CString  CNdsCard::GetMemoryType(UINT index)
{
	if(index >= GetMemoryTotal())
	{
		return "";
	}
	MEMORY_TYPE mt=m_MemoryTypeList.GetAt(index);
	
	CString type;
	PCHAR pbuffer = type.GetBuffer(STRING_MAX_LEN);
	R6GetMemoryType(mt.id,pbuffer,STRING_MAX_LEN);
	type.ReleaseBuffer();

	return type;
}
//==========================================================
//:   
//
//==========================================================
MEMORY_ID  CNdsCard::GetMemoryTypeId(UINT index)
{
	if(index >= GetMemoryTotal())
	{
		return UNKNOW;
	}
	MEMORY_TYPE mt=m_MemoryTypeList.GetAt(index);	

	return mt.id;
}


//==========================================================
//:   
//
//==========================================================
CString  CNdsCard::GetMemoryClass(UINT index)
{
	if(index >= GetMemoryTotal())
	{
		return "";
	}
	MEMORY_TYPE mt=m_MemoryTypeList.GetAt(index);

	CString class2;
	PCHAR pbuffer = class2.GetBuffer(STRING_MAX_LEN);
	R6GetMemoryClass(mt.id,pbuffer,STRING_MAX_LEN);
	class2.ReleaseBuffer();

	return class2;
}







//==========================================================
//:   
//
//==========================================================
VOID        CNdsCard::StartReadMemory(UINT index,CString filepath)
{
	//߳ռ豸,߳
	if(m_ThreadRunMode != NONEDO)
	{
		PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_DOING);
		return;
	}

	m_ThreadRun=TRUE;
	m_SelectMemoryIndex=index;
	m_FilePath=filepath;


    OutputDebugString("AfxBeginThread(ReadAllThread, this); \r\n");
	m_ThreadRunMode=READALL;
	m_Thread=AfxBeginThread(ReadAllThread, this);	
}


//==========================================================
//:   
//
//==========================================================
VOID   CNdsCard::StartWriteMemory(UINT index,CString filepath)
{
	//߳ռ豸,߳
	if(m_ThreadRunMode != NONEDO)
	{
		PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_DOING);
		return ;
	}

	m_ThreadRun=TRUE;
	m_SelectMemoryIndex=index;
	m_FilePath=filepath;


	OutputDebugString("AfxBeginThread(WriteAllThread, this); \r\n");
	m_ThreadRunMode=WRITEALL;
	m_Thread=AfxBeginThread(WriteAllThread, this);
}















//==========================================================
//: ͣ豸߳
//
//==========================================================
VOID  CNdsCard::ThreadSuspend()
{
	if((m_ThreadRunMode == NONEDO)||(m_Thread==NULL))
		return ;
	m_Thread->SuspendThread();
}




//==========================================================
//: 豸߳
//
//==========================================================
VOID  CNdsCard::ThreadResume()
{
	if((m_ThreadRunMode == NONEDO)||(m_Thread==NULL))
		return ;
	m_Thread->ResumeThread();
}




//==========================================================
//: ǿֹͣ豸߳
//
//==========================================================
VOID  CNdsCard::ThreadStop()
{
	if((m_ThreadRunMode == NONEDO)||(m_Thread==NULL))
		return ;
	m_ThreadRun  = FALSE;
	WaitForSingleObject(m_Thread->m_hThread, INFINITE);//ȴд߳̽
	m_ThreadRunMode = NONEDO;
	m_Thread=NULL;
}



//==========================================================
//: ѵǰ̹߳,ֱ豸߳̽
//
//==========================================================
VOID  CNdsCard::ThreadWait()
{
	if((m_ThreadRunMode == NONEDO)||(m_Thread==NULL))
		return ;
	//m_ThreadRun  = FALSE;
	WaitForSingleObject(m_Thread->m_hThread, INFINITE);
	m_ThreadRunMode = NONEDO;
	m_Thread=NULL;
}




//==========================================================
//: õе߳ģʽ
//
//==========================================================
THREAD_RUN_MODE  CNdsCard::GetThreadRunMode()
{
	return m_ThreadRunMode;
}







//==========================================================
//:   
//
//==========================================================
UINT  CNdsCard::ReadAllThread(LPVOID param)
{
    CNdsCard * card =(CNdsCard*)param;

	clock_t   t_begin,t_end; 
	t_begin=clock();   


	MEMORY_ENTRY_MODE mode = card->GetMemoryMode(card->m_SelectMemoryIndex);
	CR6Card autochange(mode);//Զлģʽ
	MEMORY_ID mid = card->GetMemoryTypeId(card->m_SelectMemoryIndex);

	UINT pagesize=R6GetMemorylPageSize(mid);
	UINT pagetotal=R6GetMemoryPageTotal(mid);
	PostMessage(R6GetHookWindow(),WM_READALL_START,NULL,(LPARAM)pagetotal);


	CAutoByteArray buff1(pagesize);
	PBYTE pagebuff=buff1.ptr;
	UINT  pageindex=0;
	BOOL  wstatus=FALSE;

	CAutoFile memfile(card->m_FilePath,CAutoFile::WRITE);	
	wstatus=memfile.IsSuccess();
	if(wstatus == FALSE)
	{				
		card->m_ThreadRunMode = NONEDO;
		PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_FILE);//
		return 0;
	}


	wstatus=R6MemoryReadInit(mid);
	//ʼ
	if(wstatus == FALSE)
	{				
		card->m_ThreadRunMode = NONEDO;
		PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_DEVICE);//
		return 0;
	}


	for(UINT a=0;a<pagetotal;a++)
	{

		if(!R6IsCardInsert())
		{				
			card->m_ThreadRunMode = NONEDO;	
			PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_CARD);//
			return 0;
		}

		wstatus=R6MemoryReadPage(mid,pageindex,pagebuff,pagesize);
		//
		if(wstatus == FALSE)
		{				
			card->m_ThreadRunMode = NONEDO;
			PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_DEVICE);//
			return 0;
		}
		//ǿֹ
		if(card->m_ThreadRun==FALSE)
		{					
			card->m_ThreadRunMode = NONEDO;	
			PostMessage(R6GetHookWindow(),WM_READALL_ERROR,NULL,ERROR_STOP);//
			return 0;
		}
		memfile.Write(pagebuff,pagesize);
		pageindex++;
		PostMessage(R6GetHookWindow(),WM_READALL_STEP,NULL,NULL);
	}

	card->m_ThreadRunMode = NONEDO;

	t_end=clock();   
	PostMessage(R6GetHookWindow(),WM_READALL_END,NULL,(LPARAM)(t_end-t_begin));	
	return 0;
}





//==========================================================
//:   
//
//==========================================================
UINT  CNdsCard::WriteAllThread(LPVOID param)
{
    CNdsCard * card =(CNdsCard*)param;

	clock_t   t_begin,t_end; 
	t_begin=clock(); 


	MEMORY_ENTRY_MODE mode = card->GetMemoryMode(card->m_SelectMemoryIndex);
    CR6Card autochange(mode);//Զлģʽ
	MEMORY_ID mid = card->GetMemoryTypeId(card->m_SelectMemoryIndex);


	UINT pagesize=R6GetMemorylPageSize(mid);
	UINT pagetotal=R6GetMemoryPageTotal(mid);	
	PostMessage(R6GetHookWindow(),WM_WRITEALL_START,NULL,(LPARAM)pagetotal);


	CAutoByteArray buff1(pagesize);
	PBYTE pagebuff=buff1.ptr;
	UINT  pageindex=0;
	BOOL  wstatus=FALSE;


	CAutoFile memfile(card->m_FilePath,CAutoFile::READ);	
	wstatus=memfile.IsSuccess();
	if(wstatus == FALSE)
	{	
		card->m_ThreadRunMode = NONEDO;	
		PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_FILE);//
		return 0;
	}


	wstatus=R6MemoryWriteInit(mid);
	//дʼ
	if(wstatus == FALSE)
	{	
		card->m_ThreadRunMode = NONEDO;	
		PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_DEVICE);//
		return 0;
	}


	for(UINT a=0;a<pagetotal;a++)
	{	
		if(!R6IsCardInsert())
		{	
			card->m_ThreadRunMode = NONEDO;	
			PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_CARD);//
			return 0;
		}

		memfile.Read(pagebuff, pagesize);
		wstatus=R6MemoryWritePage(mid,pageindex,pagebuff,pagesize);		


		//д
		if(wstatus == FALSE)
		{	
			card->m_ThreadRunMode = NONEDO;	
			PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_DEVICE);//
			return 0;
		}
		//ǿֹ
		if(card->m_ThreadRun==FALSE)
		{			
			card->m_ThreadRunMode = NONEDO;
			PostMessage(R6GetHookWindow(),WM_WRITEALL_ERROR,NULL,ERROR_STOP);//
			return 0;
		}
		pageindex++;
		PostMessage(R6GetHookWindow(),WM_WRITEALL_STEP,NULL,NULL);
	}

	t_end=clock(); 
	card->m_ThreadRunMode = NONEDO;
	PostMessage(R6GetHookWindow(),WM_WRITEALL_END,NULL,(LPARAM)(t_end-t_begin));	
	return 0;
}






//==========================================================
//:   
//ע: ̲ܸı
//==========================================================
UINT  CNdsCard::CheckStructureThread(LPVOID param)
{
    CNdsCard * card =(CNdsCard*)param;	
	card->m_CardType = "Unknow-Card";
	card->m_MemoryTypeList.RemoveAll();

	PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_START,NULL,12);//LPARAM 趨ܲ
    

	BOOL isr6 = FALSE;//ϷǷΪR6,norflashģʽIDΪR6
	                  //ɰR6ֻM25PE80,°R6ֻM25PE20,IDR6¾ɰ
    MEMORY_ID mid;


	CR6Card::EntryNorFlashMode();   
	mid = R6SearchStNorFlashType();	
	if(mid != UNKNOW)	
	{	
		card->m_CardType = GetR6CardName();
		card->MemoryTypeListAdd(NORFLASH,mid);	
        isr6 = TRUE;
	}
	PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);
	CR6Card::ExitNorFlashMode();



    if(isr6 == TRUE)
	{
		//------------------------------------------------------------------
		//--------------------------------------------------------------R6
		CR6Card::Entry8MEepromMode();

		// M25PE M45PE ID
		mid = R6SearchStFlashType();	
		if(mid != UNKNOW)	
		{		
			card->m_CardType = GetR6CardName();
			card->MemoryTypeListAdd(EEPROM8M,mid);
			goto  CHECKSTRUCTURE_1;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);


		// LE25FW ID
		mid = R6SearchSanyoFlashType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetR6CardName();
			card->MemoryTypeListAdd(EEPROM8M,mid);
			goto  CHECKSTRUCTURE_1;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);


		// M95 
		mid = R6SearchStEepromType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetR6CardName();
			card->MemoryTypeListAdd(EEPROM8M,mid);
			goto  CHECKSTRUCTURE_1;
		}		
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);

		
	
	    CHECKSTRUCTURE_1://---------------------------


        CR6Card::Entry512KEepromMode();

		// M25PE M45PE ID	
		mid = R6SearchStFlashType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetR6CardName();
			card->MemoryTypeListAdd(EEPROM512K,mid);
			goto  CHECKSTRUCTURE_2;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);

		// LE25FW ID
		mid = R6SearchSanyoFlashType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetR6CardName();
			card->MemoryTypeListAdd(EEPROM512K,mid);
			goto  CHECKSTRUCTURE_2;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);

		//// M95 
		mid = R6SearchStEepromType();	
		if(mid != UNKNOW)
		{	
			if(mid == M95M01)
			{
				//ע!!!  M95M01 ( -R )°R6ʱ,:MAGICKEY6GOLD236
			}
			else
			{					
				card->MemoryTypeListAdd(EEPROM512K,mid);
			}
            card->m_CardType = GetR6CardName();
			goto  CHECKSTRUCTURE_2;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);




        CHECKSTRUCTURE_2://-------------------------
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);
	}
	else
	{
		//--------------------------------------------------------------ԭװ
		//--------------------------------------------------------------------
		CR6Card::EntrySensorMode();
	
		// M25PE M45PE ID
		mid = R6SearchStFlashType();	
		if(mid != UNKNOW)	
		{ 
			card->m_CardType = GetOriginalCardName();//Original NDS Game Cart
			card->MemoryTypeListAdd(SENSOR,mid);
			goto  CHECKSTRUCTURE_END;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);
	
	
		// LE25FW ID	
		mid = R6SearchSanyoFlashType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetOriginalCardName();
			card->MemoryTypeListAdd(SENSOR,mid);
			goto  CHECKSTRUCTURE_END;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);
	
	
		// M95
		mid = R6SearchStEepromType();	
		if(mid != UNKNOW)	
		{
			card->m_CardType = GetOriginalCardName();
		    card->MemoryTypeListAdd(SENSOR,mid);
			goto  CHECKSTRUCTURE_END;
		}
		PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_STEP,NULL,NULL);
	}





CHECKSTRUCTURE_END:
	card->m_ThreadRunMode = NONEDO;
	PostMessage(R6GetHookWindow(),WM_CHECKSTRUCTURE_END,NULL,NULL);
		return 0;
}













//==========================================================
//:     ¼ Memory  MemoryList 
//==========================================================
VOID   CNdsCard::MemoryTypeListAdd(MEMORY_ENTRY_MODE mode,MEMORY_ID id)
{
	MEMORY_TYPE mem;
	mem.mode = mode;
	mem.id = id;
	m_MemoryTypeList.Add(mem);
}







//==========================================================
//:   
//==========================================================
CString       CNdsCard::GetTitle()
{
	BYTE inbuff[8];
	BYTE outbuff[1024*8];

    //----------------------------------------------------------------------------
	//͸λź,Ȼ"Get Header"صֻڵһȷ
	BYTE data[7];
	data[0]=0x08;
	data[1]=0xFF;
	data[2]=0x00;
	data[3]=0x00;
	data[4]=0x00;
	data[5]=0x00;
	data[6]=0x00;
	R6TransmitOriginalRom(data,7,NULL,0);

	////----------------------------------------------------------------------------
	////Send  "Dummy " command
	//inbuff[0] = 0x9F;
	//inbuff[1] = 0x00;
	//inbuff[2] = 0x00;
	//inbuff[3] = 0x00;
	//inbuff[4] = 0x00;
	//inbuff[5] = 0x00;
	//inbuff[6] = 0x00;
	//inbuff[7] = 0x00;
	//R6TransmitOriginalRom(inbuff,8,outbuff,0x2000);

	//----------------------------------------------------------------------------
	//Send "Get Header" command
	inbuff[0] = 0x00;
	inbuff[1] = 0x00;
	inbuff[2] = 0x00;
	inbuff[3] = 0x00;
	inbuff[4] = 0x00;
	inbuff[5] = 0x00;
	inbuff[6] = 0x00;
	inbuff[7] = 0x00;
	R6TransmitOriginalRom(inbuff,8,outbuff,0x200);


	DS_CARTRIDGE_HEADER  head;
	CopyMemory(&head,outbuff,sizeof(DS_CARTRIDGE_HEADER));
	////----------------------------------------------------------------------------
    //Send "Get ROM Chip ID" command
	//inbuff[0] = 0x90;
	//inbuff[1] = 0x00;
	//inbuff[2] = 0x00;
	//inbuff[3] = 0x00;
	//inbuff[4] = 0x00;
	//inbuff[5] = 0x00;
	//inbuff[6] = 0x00;
	//inbuff[7] = 0x00;
	//R6TransmitOriginalRom(inbuff,8,outbuff,4);
    
	return head.gametitle;
}




//==========================================================
//:   
//==========================================================
VOID       CNdsCard::BuildDSheaderFile(CString filepath)
{
	BYTE inbuff[8];
	BYTE outbuff[1024*8];

    //----------------------------------------------------------------------------
	//͸λź,Ȼ"Get Header"صֻڵһȷ
	BYTE data[7];
	data[0]=0x08;
	data[1]=0xFF;
	data[2]=0x00;
	data[3]=0x00;
	data[4]=0x00;
	data[5]=0x00;
	data[6]=0x00;
	R6TransmitOriginalRom(data,7,NULL,0);


	//----------------------------------------------------------------------------
	//Send "Get Header" command
	inbuff[0] = 0x00;
	inbuff[1] = 0x00;
	inbuff[2] = 0x00;
	inbuff[3] = 0x00;
	inbuff[4] = 0x00;
	inbuff[5] = 0x00;
	inbuff[6] = 0x00;
	inbuff[7] = 0x00;
	R6TransmitOriginalRom(inbuff,8,outbuff,0x200);


	DS_CARTRIDGE_HEADER  head;
	CopyMemory(&head,outbuff,sizeof(DS_CARTRIDGE_HEADER));

    

	CAutoFile headerfile(filepath,CAutoFile::WRITE);	
	BOOL wstatus=headerfile.IsSuccess();
	if(wstatus == TRUE)
	{				
		headerfile.WriteLine("Header Overview (loaded from ROM Addr 0 to Main RAM 27FFE00h on Power-up)");
		headerfile.WriteLine("Address Bytes Expl.                                         Value");
		headerfile.WriteLine("000h    12    Game Title  (Uppercase ASCII)                 "+CharArrayToString(head.gametitle));
		headerfile.WriteLine("00Ch    4     Gamecode    (Uppercase ASCII)                 "+CharArrayToString(head.gamcode));
		headerfile.WriteLine("010h    2     Makercode   (Uppercase ASCII)                 "+CharArrayToString(head.makercode));
		headerfile.WriteLine("012h    1     Unitcode                                      "+ByteToString(head.unitcode));
		headerfile.WriteLine("013h    1     Encryption Seed Select                        "+ByteToString(head.encryptionseedselect));
		headerfile.WriteLine("014h    1     Devicecapacity                                "+ByteToString(head.devicecapacity));
		headerfile.WriteLine("015h    9     Reserved                                      "+ByteArrayToString(head.reserved1,9));
		headerfile.WriteLine("01Eh    1     ROM Version                                   "+ByteToString(head.romversion));
		headerfile.WriteLine("01Fh    1     Autostart                                     "+ByteToString(head.autostart));

		headerfile.WriteLine("020h    4     ARM9 rom_offset                               "+UintToString(head.arm9romoffset));
		headerfile.WriteLine("024h    4     ARM9 entry_address                            "+UintToString(head.arm9entryaddress));
		headerfile.WriteLine("028h    4     ARM9 ram_address                              "+UintToString(head.arm9ramaddress));
		headerfile.WriteLine("02Ch    4     ARM9 size                                     "+UintToString(head.arm9size));
		headerfile.WriteLine("030h    4     ARM7 rom_offset                               "+UintToString(head.arm7romoffset));
		headerfile.WriteLine("034h    4     ARM7 entry_address                            "+UintToString(head.arm7entryaddress));
		headerfile.WriteLine("038h    4     ARM7 ram_address                              "+UintToString(head.arm7ramaddress));
		headerfile.WriteLine("03Ch    4     ARM7 size                                     "+UintToString(head.arm7size));
		headerfile.WriteLine("040h    4     File Name Table (FNT) offset                  "+UintToString(head.filenametalbeoffset));
		headerfile.WriteLine("044h    4     File Name Table (FNT) size                    "+UintToString(head.filenametablesize));
		headerfile.WriteLine("048h    4     File Allocation Table (FAT) offset            "+UintToString(head.fileallocationtableoffset));
		headerfile.WriteLine("04Ch    4     File Allocation Table (FAT) size              "+UintToString(head.fileallocationtablesize));
		headerfile.WriteLine("050h    4     File ARM9 overlay_offset                      "+UintToString(head.filearm9overlayoffset));
		headerfile.WriteLine("054h    4     File ARM9 overlay_size                        "+UintToString(head.filearm9overlaysize));
		headerfile.WriteLine("058h    4     File ARM7 overlay_offset                      "+UintToString(head.filearm7overlayoffset));
		headerfile.WriteLine("05Ch    4     File ARM7 overlay_size                        "+UintToString(head.filearm7overlaysize));
		headerfile.WriteLine("060h    4     Port 40001A4h setting for normal commands     "+UintToString(head.normalcommands));
		headerfile.WriteLine("064h    4     Port 40001A4h setting for KEY1 commands       "+UintToString(head.key1commands));
		headerfile.WriteLine("068h    4     Icon_title_offset                             "+UintToString(head.icontitleoffset));

		headerfile.WriteLine("06Ch    2     Secure Area Checksum                          "+UshortToString(head.secureareachecksum));
		headerfile.WriteLine("06Eh    2     Secure Area Loading Timeout                   "+UshortToString(head.securearealoading));

		headerfile.WriteLine("070h    4     ARM9 Auto Load List RAM Address               "+UintToString(head.arm9autoloadlist));
		headerfile.WriteLine("074h    4     ARM7 Auto Load List RAM Address               "+UintToString(head.arm7autoloadlist));

		headerfile.WriteLine("078h    8     Secure Area Disable                           "+ByteArrayToString(head.secureareadisable,0x08));

		headerfile.WriteLine("080h    4     Total Used ROM size                           "+UintToString(head.totalusedromsize));
		headerfile.WriteLine("084h    4     ROM Header Size                               "+UintToString(head.romheadersize));

		headerfile.WriteLine("088h    38h   Reserved                                      "+ByteArrayToString(head.reserved2,0x38));
		headerfile.WriteLine("0C0h    9Ch   Nintendo Logo                                 "+ByteArrayToString(head.nintendologo,0x9c));

		headerfile.WriteLine("15Ch    2     Nintendo Logo Checksum                        "+UshortToString(head.nintendologochecksum));
		headerfile.WriteLine("15Eh    2     Header Checksum                               "+UshortToString(head.headerchecksum));

		headerfile.WriteLine("160h    4     Debug rom_offset                              "+UintToString(head.debugromoffset));
		headerfile.WriteLine("164h    4     Debug size                                    "+UintToString(head.debugsize));
		headerfile.WriteLine("168h    4     Debug ram_address                             "+UintToString(head.debugramaddress));
		headerfile.WriteLine("16Ch    4     Reserved                                      "+ByteArrayToString(head.reserved3,0x04));

		headerfile.WriteLine("170h    90h   Reserved                                      "+ByteArrayToString(head.reserved4,0x90));
	}
}


//==========================================================
//:   
//==========================================================
CString    CNdsCard::CharArrayToString(char * pbuff)
{
	CString xx(pbuff);
	return xx;
}


//==========================================================
//:   
//==========================================================
CString    CNdsCard::UintToString(UINT buff)
{
	CString xx;
	xx.Format("0x%x",buff);
	return xx;
}


//==========================================================
//:   
//==========================================================
CString    CNdsCard::UshortToString(USHORT buff)
{
	CString xx;
	xx.Format("0x%x",buff);
	return xx;
}


//==========================================================
//:   
//==========================================================
CString   CNdsCard::ByteToString(BYTE buff)
{
	CString xx;
	xx.Format("0x%x",buff);
	return xx;
}


//==========================================================
//:   
//==========================================================
CString    CNdsCard::ByteArrayToString(PBYTE pbuff,UINT len)
{
	CString xx="";
	CString yy="";
    for(UINT aa=0;aa<len;aa++)
	{
		xx.Format("0x%x,",pbuff[aa]);
       yy=yy+xx;
	   /*
	   if((aa%8)==0)
	   {
		   yy=yy+"\r\n";
	   }
	   */
	}
	return yy;
}


//==========================================================
//:   
//==========================================================
CString    CNdsCard::GetR6CardName()
{
	return "NEO R6 CARD";
}




//==========================================================
//:   
//==========================================================
CString   CNdsCard::GetOriginalCardName()
{
	return "Original NDS Game Cart";
}
